/* ---*-C++-*---------------------------------------------------------------
Copyright (C) 1999, 2000, 2001 Simon Patarin, INRIA

This file is part of Pandora, the Flexible Monitoring Platform.

Pandora is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Pandora is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Pandora; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#ifndef PANDORA_ENTRY_H
#define PANDORA_ENTRY_H

class StackEntry;
class CompEntry;
class OptionEntry;

class PandoraEntry {
private:
  StackEntry 	*se;
  CompEntry 	*ce;
  OptionEntry 	*oe;

public:
  PandoraEntry(void) : se(NULL), ce(NULL), oe(NULL) { }
  virtual ~PandoraEntry(void) { reset(); }
  void reset(void);

  void setStack(StackEntry *);
  StackEntry *takeStack(void);
  
  void setComponent(CompEntry *);
  CompEntry *takeComponent(void);
  
  void setOption(OptionEntry *);
  OptionEntry *takeOption(void);  

  StackEntry  *stack(void) 	{ return se; }
  CompEntry   *component(void) 	{ return ce; }
  OptionEntry *option(void) 	{ return oe; }
};

#endif /* PANDORA_ENTRY_H */
