/* ---*-C++-*---------------------------------------------------------------
Copyright (C) 1999, 2000, 2001 Simon Patarin, INRIA

This file is part of Pandora, the Flexible Monitoring Platform.

Pandora is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Pandora is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Pandora; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


#ifndef SERVER_H
#define SERVER_H

#include <libpandora/global.h>

extern "C" {
#include <libpandora/conf/string.h>
	   }

#include <iostream>
#include <libpandora/netselect.h>

class Server {
private:
  NetSelect *sel;

public:

  Server(void) : sel(NULL) { }
  virtual ~Server(void);

  bool init(NetSelect::net_func_t *func, void *data, int port, 
	    bool inet, bool stream);
  int fileDesc(void) { return (sel != NULL) ? sel->fileDesc() : -1 ; }
  inline bool process(void);
};

bool Server::process(void) 
{ 
  pandora_assert(sel != NULL);
  return (sel->select() < 0); 
}

#endif /* SERVER_H */
