/* Copyright (C) 1999, 2000, 2001 Simon Patarin, INRIA

This file is part of Pandora, the Flexible Monitoring Platform.

Pandora is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Pandora is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Pandora; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <libpandora/global.h>

#include "fseventscancomponent.h"
#include <pandora_components/fseventpacket.h>
#include <pandora_components/syscallpacket.h>
#include <libpandora/error.h>

component_export(FSEventScanComponent, SyscallPacket, FSEventPacket);

bool FSEventScanComponent::add(Packet *p) 
{
  bool ret = false, _push = false;

  SyscallPacket *sp = static_cast<SyscallPacket *>(p);
  if (sp->retval < 0) return_clean(sp);

  switch (sp->type) {
  case SyscallPacket::OPEN:  dispatch(); break;
  case SyscallPacket::CLOSE: _push = ret = true;  
  default: break;
  }

  if (fsep == NULL) {
    fsep = new FSEventPacket(sp);
  } else {
    fsep->update(sp);
    cleanPacket(sp);
  }

  if (_push) dispatch();
  return ret;
}

void FSEventScanComponent::cleanup(void) 
{
  dispatch();
}
