/* Copyright (C) 1999, 2000, 2001 Simon Patarin, INRIA

This file is part of Pandora, the Flexible Monitoring Platform.

Pandora is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Pandora is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Pandora; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <libpandora/global.h>

#include <pandora_components/httppacket.h>
#include "httpanoncomponent.h"
#include <libpandora/anonymize.h>

component_export(HTTPAnonComponent, HTTPPacket+, Packet);

bool HTTPAnonComponent::add(Packet* pkt)    
{
  locatePacket0(HTTPPacket, httpp, pkt);

  if (httpp != NULL) {
    if ((httpp->type == HTTPPacket::request) && (key != NULL)) {
      httpp->hashed = true;
      hash_url(httpp->url, *key, depth);
      hash_url(httpp->ref, *key, depth);
      hash_text(httpp->host, *key);
    }
  }
  
  push(pkt);
  return false;
}
