/* ---*-C++-*---------------------------------------------------------------
Copyright (C) 1999, 2000, 2001 Simon Patarin, INRIA

This file is part of Pandora, the Flexible Monitoring Platform.

Pandora is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Pandora is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Pandora; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


#ifndef HTTP_ANON_COMPONENT_H
#define HTTP_ANON_COMPONENT_H

#include <libpandora/global.h>

#include <libpandora/component.h>
#include <libpandora/text.h>
#include <libpandora/common_options.h>

class HTTPPacket;

class HTTPAnonComponent : public Component {
private:
  text *key;
  int depth;

public:

  component_init(HTTPAnonComponent, 1);
  inline HTTPAnonComponent(void);
  virtual ~HTTPAnonComponent(void) { }
  
  virtual bool add(Packet*);
};

HTTPAnonComponent::HTTPAnonComponent(void) : key(NULL), depth(1)
{
  registerStaticOption(template_option<text>, "key", &key);
  registerOption("depth", &depth);
}

#endif /* HTTP_ANON_COMPONENT_H */
