/* Copyright (C) 1999, 2000, 2001 Simon Patarin, INRIA

This file is part of Pandora, the Flexible Monitoring Platform.

Pandora is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Pandora is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Pandora; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <libpandora/global.h>
#include <libpandora/common_options.h>
#include <libpandora/pktutil.h>

#include "loggercomponent.h"

component_export(LoggerComponent, Packet, Packet);

LoggerComponent::LoggerComponent(void)
  : f(stdout)
{
  registerStaticOption(write_file_option, "file", &f);
}

bool LoggerComponent::add(Packet *pkt)
{
  int len = 0;

  if (f != NULL) 
    len = packet_send(pkt, f, buf, MAX_PACKET_SIZE);

  push(pkt);

  return false;
    
}

