/* ---*-C++-*---------------------------------------------------------------
Copyright (C) 1999, 2000, 2001 Simon Patarin, INRIA

This file is part of Pandora, the Flexible Monitoring Platform.

Pandora is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Pandora is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Pandora; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


#ifndef NDEMUX_COMPONENT_H
#define NDEMUX_COMPONENT_H

#include <libpandora/global.h>

extern "C" {
#include <assert.h>
	   }

#include <libpandora/demap.h>
#include <libpandora/component.h>
#include <libpandora/common_options.h>
#include <libpandora/smart_ptr.h>
#include <libpandora/dmxkey.h>

class NDemuxComponent : public Component {
private:
  typedef smart_ptr<DmxKey> key_t;
  typedef DmxKey *(*dmx_func_t)(Packet *);
  typedef DEMap<key_t, int> KeyMap;

  KeyMap kmap;
  dmx_func_t func;
  int idx;


public:
  component_init(NDemuxComponent, 1);
  inline  NDemuxComponent(void);
  virtual ~NDemuxComponent(void);

  virtual bool add(Packet *pkt);
  virtual bool notify(Component *c);
};

NDemuxComponent::NDemuxComponent(void) 
  : func(NULL), idx(0) 
{ 
  registerComplexOption(symbol_option, "algo", &func); 
}

#endif /* NDEMUX_COMPONENT_H */

