/* ---*-C++-*---------------------------------------------------------------
Copyright (C) 1999, 2000, 2001 Simon Patarin, INRIA

This file is part of Pandora, the Flexible Monitoring Platform.

Pandora is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Pandora is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Pandora; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


#ifndef NET_READER_COMPONENT_H
#define NET_READER_COMPONENT_H

#include <libpandora/global.h>

#include <libpandora/inputcomponent.h>
#include <libpandora/pandora_limits.h>

class Server;  

class NetReaderComponent : public InputComponent {
private:
  char buf[MAX_PACKET_SIZE];
  int current_fd;
  bool usock;

protected:
  int listen;
  Server *svr;

public:

  component_init(NetReaderComponent, 1);
  inline  NetReaderComponent(void);
  virtual ~NetReaderComponent(void) { }

  virtual int  init(void);
  virtual bool process(void);
  virtual void finish(void);

  virtual bool pull(Packet *pkt);

  static bool accept(int fd, void *udata);
  
private:
  bool read(int fd);
};


NetReaderComponent::NetReaderComponent(void) 
  : current_fd(-1), usock(false), listen(0), svr(NULL) 
{
  registerOption("listen", &listen);
  registerOption("unix", &usock);
}

#endif /* NET_READER_COMPONENT_H */
