/* ---*-C++-*---------------------------------------------------------------
Copyright (C) 1999, 2000, 2001 Simon Patarin, INRIA

This file is part of Pandora, the Flexible Monitoring Platform.

Pandora is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Pandora is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Pandora; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


#ifndef VAL_SOURCE_COMPONENT_H
#define VAL_SOURCE_COMPONENT_H

#include <libpandora/global.h>

#include <libpandora/inputcomponent.h>

class ValSourceComponent : public InputComponent {
private:
  int  type;
  bool doRand;
  char *str;

public:
  component_init(ValSourceComponent, 1);
  inline ValSourceComponent(void);
  virtual ~ValSourceComponent(void) { }

  virtual int  init(void);
  virtual bool process(void);  
  virtual void finish(void) { }
};

ValSourceComponent::ValSourceComponent(void) 
  : type(0), doRand(true)
{ 
  registerOption("type", &type);
  registerOption("random", &doRand);
  registerOption("string", &str);
}

#endif /* VAL_SOURCE_COMPONENT_H */
